#include <stdlib.h>
#include <ctype.h>

#include "gttypes.h"

/* Table of characters. */
static const char bchrs[]=
{
	'0','1','2','3','4','5','6','7','8','9',
	'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r',
	's','t','u','v','w','x','y','z'
};

/************************************************************************\
*
* Replacement for the 'strtol' function.
*
\************************************************************************/
long int strtol(const char *nptr,char **endptr,int base)
{
	int n;
	char *s,neg=0;
	long int res=0;
	
	s=(char *)nptr;
	while(*s && isspace(*s))
		s++;
	if(*s == '+')
		s++;
	else if(*s == '-')
	{
		s++;
		neg = 1;
	}
	if(base == 0)
	{
		if(*s && (*s == '0'))
		{
			s++;
			if(*s && (*s == 'x'))
			{
				s++;
				base = 16;
			}
			else
				base = 8;
		}
		else
			base = 10;
	}
	if((base >= 2) && (base <= 36))
	{
		while(*s && (isdigit(*s) || isalpha(*s)))
		{
			for(n = 0; (n < 36) && (n < base); n++)
			{
				if(bchrs[n] == *s)
					break;
			}
			if(n == base)
				break;
			res *= base;
			if(neg)
				res -= n;
			else
				res += n;
			s++;
		}
	}
	if(endptr)
		*endptr = s;
	return(res);
}
