#ifndef INC_GTFONT_H
#define INC_GTFONT_H

#include <X11/Xlib.h>

#include "gtbase.h"
#include "gtdisplay.h"

/************************************************************************\
*
* GtFont class header.
*
* $Ident: This file is part of the 'Gt-library' 1.0.0 $
* $Copyright: (C) 1997 by Gran Gustafsson $
*
\************************************************************************/

class GtFont : public GtBase
{
public:
		/* Standard */
	GtFont(void);
	void Destroy(void);
	void DeInit(void);
	sbool Init(GtDisplay *d,GtTag *tgs);
	sbool Init(GtTag *tgs);
	sbool Set(GtTag *tgs);
	void Get(GtTag *tgs);
	char *GetClass(void) { return("GtFont"); }
	sbool IsSubClassOf(char *cn);
		/* Sizes */
	void StrExtents(char *str,int len,XCharStruct *xcs);
	void MinExtents(XCharStruct *xcs);
	void MaxExtents(XCharStruct *xcs);
	inline int StrWidth(char *str,int len)
	{
		return(XTextWidth(fs,str,len));
	}
	inline int CharWidth(char c)
	{
		return(XTextWidth(fs,&c,1));
	}
	int StrFit(char *str,int len,int xsize,int *fxs);
		/* Values */
	inline Font XFnt(void) { return(fnt); }
		/* Friends */
	friend GtFont *GtMkFont(GtDisplay *d,GtTag *tgs);
protected:
	GtDisplay *dsp;
	GtFont *next;
	XFontStruct *fs;
	Font fnt;
	char *fname;
	int cnt;
	sbool nofreex;
};

extern GtFont *GtMkFont(GtDisplay *d,GtTag *tgs);
extern GtFont *GtMkFont(GtDisplay *d,ulong tag,...);

#endif /* INC_GTFONT_H */
